#if defined TutorAPI
	#endinput
#endif

#define TutorAPI

//  
enum
{
	TutorTypeDefault = 1,		// |        |   | 
	TutorTypeFriendDeath = 2,	// |           |   | 
	TutorTypeEnemyDeath = 4,	// |           |     | 
	TutorTypeScenario = 8,		// |           | Ƹ   | 
	TutorTypeBuy = 16,			// |            |   | 
	TutorTypeCareer = 32,		// |              |   | 
	TutorTypeHint = 64,			// |          |   | 
	TutorTypeInGameHint = 128,	// |   |   | 
	TutorTypeEndGame = 256		// |          | Ƹ   | 
};

// 
enum
{
	TutorSoundNone = -1,		//  
	TutorSoundEnemyDeath,		//  
	TutorSoundFriendDeath,		//  
	TutorSoundTaskComplete,		//  
	TutorSoundTutorMsg			//  
};

/*
	[ TutorReliable ]
	
	[  ]
	   ,   .
	!!!     ,   !!!
	
	[  ]
	| 	| 			|  			| 
	----------------------------------------------------------------------------------------
	| bReliable	| 		| false					| 
	
	[  ]
	TutorReliable(false);
	TutorReliable(true);
*/
native TutorReliable(bool:bReliable);

/*
	[ TutorShow ]
	
	[  ]
	   /.
	
	[  ]
	| 	| 			|  			| 
	----------------------------------------------------------------------------------------
	| iEntity	| 	| 0						|      (0 - )
	| iType		| 	| TutorTypeDefault		|   (  )
	| fTime		| 		| 0.0					|     (0.0 - )
	| iSound	| 	| TutorSoundNone		|    (  )
	| iMessage	| 	| 						| 
	| ...		|				|						|   
	
	[  ]
	TutorShow(0, TutorTypeScenario, 0.0, TutorSoundTaskComplete, "You are complete your %d task!", 5);
	TutorShow(id, TutorTypeHint, 5.0, TutorSoundTutorMsg, "To buy weapon press ^"B^" key");
*/
native TutorShow(iEntity = 0, iType = TutorTypeDefault, Float:fTime = 0.0, iSound = TutorSoundNone, const iMessage[], any:...);

/*
	[ TutorClose ]
	
	[  ]
	   /.
	
	[  ]
	| 	| 			|  			| 
	----------------------------------------------------------------------------------------
	| iEntity	| 	| 0						|       (0 - )
	
	[  ]
	TutorClose(id);
	TutorClose(0);
*/
native TutorClose(iEntity = 0);