#if определено _reapi_included
	#endinput
#endif

#define  _reapi_included

#if AMXX_VERSION_NUM > =  175
	#pragma  reqlib reapi
	#if ! fined AMXMODX_NOAUTOLOAD
		#pragma  loadlib reapi
	#endif
#else
	#pragma  библиотека reapi
#endif

enum hooks_tables_e
{
	ht_engine ,
	ht_gamedll ,
	ht_animating ,
	ht_player ,
	ht_gamerules ,
	ht_rechecker ,
	ht_grenade ,
	ht_weaponbox
};

enum members_tables_e
{
	mt_gamerules ,
	mt_base ,
	mt_animating ,
	mt_basemonster ,
	mt_player ,
	mt_entvars ,
	mt_playermove ,
	mt_movevars ,
	mt_usercmd ,
	mt_pmtrace ,
	mt_csplayer ,
	mt_baseitem ,
	mt_baseweapon ,
	mt_weaponbox ,
	mt_armoury ,
	mt_grenade ,
	mt_p228 ,
	mt_scout ,
	mt_hegrenade ,
	mt_xm1014 ,
	MT_C4 ,
	mt_mac10 ,
	mt_aug ,
	mt_smokegrenade ,
	mt_elite ,
	mt_fiveseven ,
	mt_ump45 ,
	mt_sg550 ,
	mt_galil ,
	mt_famas ,
	mt_usp ,
	mt_glock18 ,
	mt_awp ,
	mt_mp5n ,
	mt_m249 ,
	mt_m3 ,
	mt_m4a1 ,
	mt_tmp ,
	mt_g3sg1 ,
	mt_deagle ,
	mt_sg552 ,
	mt_ak47 ,
	mt_knife ,
	MT_p90 ,
	mt_shield ,
	mt_rebuystruct ,
	mt_mapinfo ,
	mt_csplayerweapon
};

// Это как FNullEnt
#define  is_nullent (% 0 )           (% 0  ==  0  ||  is_entity (% 0 )  ==  false )

#define  MAX_REGION_RANGE         1024

#define  BEGIN_FUNC_REGION (% 0 )    ( любой : MAX_REGION_RANGE * hooks_tables_e : ht_ % 0 )
#define  BEGIN_MEMBER_REGION (% 0 )  ( любой : MAX_REGION_RANGE * members_tables_e : mt_ % 0 )

#include < cssdk_const >

#include < reapi_version >
#include < reapi_engine >   // @note: только для ReHLDS
#include < reapi_gamedll >  // @note: только для gamedll Counter-Strike (ReGameDLL_CS)

// аддоны
#include < reapi_vtc >
#include < reapi_reunion >
#include < reapi_rechecker >

/ * *
* Типы возврата Hookchain
* /
перечисление
{
	HC_CONTINUE =  0 ,  // Плагин не предпринимал никаких действий
	HC_SUPERCEDE ,     // Пропустить реальную функцию, использовать мое возвращаемое значение
	HC_BREAK          // Пропустить все форварды и реальную функцию, используйте мое возвращаемое значение
                     // @note Предупреждение: будьте очень осторожны, использование этого типа возврата пропустит вызовы для всех следующих плагинов AMXX
};

/ * *
* Типы аргументов Hookchain
* /
enum AType
{
	ATYPE_INTEGER =  0 ,
	ATYPE_FLOAT ,
	ATYPE_STRING ,
	ATYPE_CLASSPTR ,
	ATYPE_EDICT
};

enum HookChain
{
	INVALID_HOOKCHAIN =  0
};

/ *
* Hook API функция, которая доступна в enum.
* Посмотрите на перечисления для списков параметров.
*
* @param function Функция для подключения
* @param callback Переадресация вызова
* @param post Выслать или нет это в посте
*
* @return Возвращает дескриптор крюка. Используйте EnableHookChain / DisableHookChain, чтобы включить или выключить форвард
* /
родной HookChain : RegisterHookChain ({ EngineFunc , GamedllFunc , GamedllFunc_CBaseAnimating , GamedllFunc_CBasePlayer , GamedllFunc_CSGameRules , GamedllFunc_CGrenade , GamedllFunc_CWeaponBox , ReCheckerFunc }: function_id , Const обратного вызова [], пост =  0 );

/ *
* Останавливает крючок от срабатывания.
* Используйте возвращаемое значение из RegisterHookChain в качестве параметра здесь!
*
* @param hook Крюк, чтобы остановить
*
* /
родной bool : DisableHookChain ( HookChain : hook );

/ *
* Запускает крюк обратно.
* Используйте возвращаемое значение из RegisterHookChain в качестве параметра здесь!
*
* @param hook Крюк для повторного включения
*
* @return Возвращает true, если функция успешно выполнена, иначе false
* /
родной bool : EnableHookChain ( HookChain : hook );

/ *
* Устанавливает возвращаемое значение цепочки.
*
* @param type Чтобы указать параметр ATYPE_ *, посмотрите перечисление AType
* @param value Значение для установки возврата
*
* /
родной SetHookChainReturn ( AType : type ,  any : ...);

/ *
* Получает возвращаемое значение текущей цепочки.
* Это не имеет никакого эффекта в предварительной цепочке.
*
* @param type Чтобы указать параметр ATYPE_ *, посмотрите перечисление AType
* @param [maxlen] Максимальная длина строки (необязательно)
*
* @return Если целое число или логическое значение или один байт или число с плавающей запятой, массив или все остальное передается через 1-й аргумент и более
* /
native any : GetHookChainReturn ( AType : type ,  any : ...);

/ *
* Установить аргумент зацепки.
* Это не имеет никакого эффекта в цепочке сообщений.
*
* @param number Номер аргумента
* @param value Новое значение
* @param [maxlen] Максимальная длина строки (необязательно)
*
* @return Возвращает true, если функция успешно выполнена, иначе false
* /
собственный SetHookChainArg ( число ,  AType : тип ,  любое : ...);

/ *
* Сравнивает сущность с указанным именем класса.
* @note Этот натив также проверяет действительность объекта.
*
* @ return true / false
* /
родной bool : FClassnameIs ( const entityIndex , const className []);

/ *
* Чтобы получить WeaponIdType от гранаты
*
* @param entity Гранатометный объект
*
* @return возвращает перечисление WeaponIdType
* /
native WeaponIdType : GetGrenadeType ( const entityIndex );

/ *
* Устанавливает вид объекта на клиенте.
* Это позволяет pfnSetView в состоянии перехватывать.
*
* @param index Клиентский индекс
* @param viewEntity Entity index
*
* /
родной engset_view ( const index , const const viewEntity );

/ *
* Получает индекс возврата текущего объекта представления на клиенте.
*
* @param index Клиентский индекс
*
* /
родной get_viewent ( константный индекс );

/ *
* Проверьте, является ли объект действительным.
*
* @ return true / false
* /
родной bool : is_entity ( const entityIndex );

/ *
* Проверьте, доступен ли ReHLDS.
*
* @ return true / false
* /
родной bool : is_rehlds ();

/ *
* Проверьте, доступен ли ReGameDLL.
*
* @ return true / false
* /
родной bool : is_regamedll ();

/ *
* Проверьте, доступно ли Воссоединение.
*
* @ return true / false
*
* /
родной bool : has_reunion ();

/ *
* Проверьте, доступен ли VTC.
*
* @ return true / false
* /
родной bool : has_vtc ();

/ *
* Проверьте, доступен ли Rechecker.
*
* @ return true / false
* /
родной bool : has_rechecker ();

/ *
* Это обратный вызов от модуля, который дает основные / вспомогательные версии для проверки совместимости для версий ReAPI.
* Если плагин AMXX получает сбой, вам необходимо обновить его до последней версии модуля ReAPI или обновить файлы, включенные для плагинов AMXX.
* Не изменяйте это!
* /
public __reapi_version_check ( const majorVersion , const minorVersion )
{
	if ( majorVersion ! = REAPI_VERSION_MAJOR )
	{
		новый темп [ 512 ];
		formatex ( temp , sizeof temp -  1 ,  "[ReAPI]: несоответствие основной версии API; ожидаемый% d, реальный% d" , REAPI_VERSION_MAJOR , majorVersion );
		set_fail_state ( temp );
		возврат ;
	}

	if ( minorVersion < REAPI_VERSION_MINOR )
	{
		новый темп [ 512 ];
		formatex ( temp , sizeof temp -  1 ,  "[ReAPI]: несоответствие минорной версии Api; ожидается не менее% d, реальный% d" , REAPI_VERSION_MINOR , minorVersion );
		set_fail_state ( temp );
		возврат ;
	}
}