#if определено _reapi_gamedll_included
	#endinput
#endif

#define  _reapi_gamedll_included

#include < reapi_gamedll_const >

/ *
* Устанавливает Think callback для сущности
*
* @param entity Entity index
* @param callback Переадресация вызова
* @param params Необязательный набор данных для передачи в обратный вызов
* @param len Необязательный размер данных
*
* @note Используйте "" для сброса обратного вызова
* @note Callback должен содержать передаваемые аргументы как "public Think_Callback (const ent)"
*
* @без возврата
* /
собственный SetThink ( const ent , const callback [], const params []  =  "" , const len =  0 );

/ *
* Устанавливает сенсорный обратный вызов для объекта
*
* @param entity Entity index
* @param callback Переадресация вызова
* @param params Необязательный набор данных для передачи в обратный вызов
* @param len Необязательный размер данных
*
* @note Используйте "" для сброса обратного вызова
* @note Callback должен содержать передаваемые аргументы как "public Touch_Callback (const ent, const other)"
*
* @без возврата
* /
собственный SetTouch ( const ent , const callback [], const params []  =  "" , const len =  0 );

/ *
* Устанавливает использование обратного вызова для объекта
*
* @param entity Entity index
* @param callback Переадресация вызова
* @param params Необязательный набор данных для передачи в обратный вызов
* @param len Необязательный размер данных
*
* @note Используйте "" для сброса обратного вызова
* @note Callback должен содержать передаваемые аргументы как "public Use_Callback (const ent, const activator, const caller, USE_TYPE: useType, Float: value)"
*
* @без возврата
* /
собственный SetUse ( const ent , const callback [], const params []  =  "" , const len =  0 );

/ *
* Устанавливает заблокированный обратный вызов для объекта
*
* @param entity Entity index
* @param callback Переадресация вызова
* @param params Необязательный набор данных для передачи в обратный вызов
* @param len Необязательный размер данных
*
* @note Используйте "" для сброса обратного вызова
* @note Callback должен содержать передаваемые аргументы как "public Blocked_Callback (const ent, const other)"
*
* @без возврата
* /
собственный SetBlocked ( const ent , const callback [], const params []  =  "" , const len =  0 );

/ *
* Устанавливает обратный вызов MoveDone для объекта
*
* @param entity Entity index
* @param callback Переадресация вызова
* @param params Необязательный набор данных для передачи в обратный вызов
* @param len Необязательный размер данных
*
* @note Используйте "" для сброса обратного вызова
* @note Entity должен быть унаследован от CBaseToggle, в противном случае может произойти сбой сервера
* @note Callback должен содержать передаваемые аргументы как "public MoveDone_Callback (const ent)"
*
* @без возврата
* /
собственный SetMoveDone ( const ent , const callback [], const params []  =  "" , const len =  0 );

/ *
* Устанавливает значение для членов CSGameRules_Members.
*
* @param member Указанный член, посмотрите на перечисления с именем CSGameRules_Members
*
* @ возврат 1 в случае успеха.
* /
родной set_member_game ( CSGameRules_Members : member ,  any : ...);

/ *
* Возвращает значение от членов CSGameRules_Members
*
* @param member Указанный член, посмотрите на перечисления с именем CSGameRules_Members
*
* @return Если через 3-й аргумент передается целое число или логическое значение, либо один байт, массив или все остальное, посмотрите список аргументов для указанного члена
* /
родной any : get_member_game ( CSGameRules_Members : member ,  any : ...);

/ *
* Устанавливает значение для члена сущности.
*
* @param index Entity index
* @param member Указанный член, посмотрите на перечисления с именем * _Members
*
* @ возврат 1 в случае успеха.
* /
родной set_member ( индекс const ,  любой : член ,  любой : ...);

/ *
* Возвращает значение от члена сущности.
*
* @param index Entity index
* @param member Указанный член, посмотрите на перечисления с именем * _Members
*
* @return Если через 3-й аргумент передается целое число или логическое значение, либо один байт, массив или все остальное, посмотрите список аргументов для указанного члена
* /
родной any : get_member ( const index ,  any : member ,  any : ...);

/ *
* Устанавливает playermove var.
*
* @param var Указанный playermove, посмотрите enum PlayerMove
*
* @ возврат 1 в случае успеха.
* /
родной set_pmove ( const PlayerMove : var ,  any : ...);

/ *
* Возвращает игрок перемещается вар.
*
* @param var Указанный playermove var, посмотрите перечисления PlayerMove
*
* @return Если целое или логическое значение, или один байт, массив или все остальное передается через 3-й аргумент и более, посмотрите список аргументов для указанного mvar
* /
родной any : get_pmove ( const PlayerMove : var ,  any : ...);

/ *
* Устанавливает значение movevar для перемещения игрока.
*
* @param var Указанный mvar, посмотрите перечисление MoveVars
*
* @ возврат 1 в случае успеха.
* /
родной set_movevar ( const MoveVars : var ,  any : ...);

/ *
* Возвращает значение movevar из хода игрока.
*
* @param var Указанный mvar, посмотрите перечисление MoveVars
*
* @return Если целое или логическое значение, или один байт, массив или все остальное передается через 3-й аргумент и более, посмотрите список аргументов для указанного mvar
* /
родной any : get_movevar ( const MoveVars : var ,  any : ...);

/ *
* Устанавливает переменную pmtrace.
*
* @param var Указанный mvar, посмотрите перечисление PMTrace
*
* @ возврат 1 в случае успеха.
* /
родной set_pmtrace ( const tracehandle , const PMTrace : var ,  any : ...);

/ *
* Возвращает переменную pmtrace
*
* @param var Указанный mvar, посмотрите перечисление PMTrace
*
* @return Если целое или логическое значение, или один байт, массив или все остальное передается через 3-й аргумент и более, посмотрите список аргументов для указанного mvar
* /
native any : get_pmtrace ( const tracehandle , const PMTrace : var ,  any : ...);

/ *
* Устанавливает член RebuyStruct.
*
* @param var Указанный RebuyStruct, посмотрите перечисление RebuyStruct
*
* @ возврат 1 в случае успеха.
* /
собственный set_rebuy ( const RebuyHandle : rebuyhandle , const RebuyStruct : member , value );

/ *
* Возвращает член RebuyStruct
*
* @param var Указанный RebuyStruct, посмотрите перечисление RebuyStruct
*
* @return Если целое или логическое значение, или один байт, массив или все остальное передается через 3-й аргумент и более, посмотрите список аргументов для указанного RebuyStruct
* /
родной get_rebuy ( const RebuyHandle : rebuyhandle ,  RebuyStruct : member );

/ *
* Назначьте номер анимации игрока.
*
* @param index Клиентский индекс
* @param playerAnim Конкретный номер анимации
*
* @без возврата
* /
родной rg_set_animation (постоянный индекс ,  PLAYER_ANIM : playerAnim );

/ *
* Добавляет деньги на счет игрока.
*
* @param index Клиентский индекс
* @param amount Количество денег
* @param bTrackChange Если bTrackChange равен 1, сумма добавленных денег также будет отображаться.
*
* @без возврата
* /
родной rg_add_account ( Const индекс , количество ,  AccountSet : Typeset = AS_ADD , Const BOOL : bTrackChange =  истинно );

/ *
* Дает игроку предмет.
*
* @param index Клиентский индекс
* @param pszName Item имя класса
* @param type Посмотрите на перечисления с именем GiveType
*
* @return Индекс объекта, если успешно, -1 в противном случае
* /
собственный rg_give_item ( константный индекс , константный pszName [],  GiveType : type = GT_APPEND );

/ *
* Дает игроку пользовательский элемент, это означает, что он не обрабатывает вещи API.
*
* @example rg_give_custom_item (id, "arms_c4"); не устанавливает для члена m_bHasC4 значение true, как это делает rg_give_item.
*
* @param index Клиентский индекс
* @param pszName Item имя класса
* @param type Посмотрите на перечисления с именем GiveType
* @param uid Устанавливает уникальный индекс для сущности
*
* @return Индекс объекта, если успешно, -1 в противном случае
*
* /
родной rg_give_custom_item ( const index , const pszName [],  GiveType : type = GT_APPEND , const uid =  0 );

/ *
* Дайте предметы по умолчанию игроку.
*
* @param index Клиентский индекс
*
* @без возврата
* /
родной rg_give_default_items (постоянный индекс );

/ *
* Дает игроку щит
*
* @param index Клиентский индекс
* @param bDeploy для развертывания щита
*
* @без возврата
* /
родной rg_give_shield ( const index , const bool : bDeploy =  true );

/ *
* Наносит урон в радиусе от исходной позиции.
*
* @param vecSrc Исходная позиция
* @param inflictor Inflictor - это объект, который нанес ущерб (например, пистолет)
* @param атакующий Атакующий - это объект, который вызвал урон (например, владелец оружия)
* @param flDamage Количество урона
* @param flRadius Радиус повреждения
* @param iClassIgnore Чтобы указать классы, которые неуязвимы для урона
* @param bitsDamageType Тип урона DMG_ *
*
* @без возврата
* /
native rg_dmg_radius ( Float : vecSrc [ 3 ], const inflictor , const атакующий , const Float : flDamage , const Float : flRadius , const iClassIgnore , const bitsDamageType );

/ *
* Сбрасывает глобальный аккумулятор нескольких повреждений.
*
* @без возврата
* /
родной rg_multidmg_clear ();

/ *
* Наносит содержимое глобального мульти-урона, зарегистрированного на жертве.
*
* @param inflictor Inflictor - это объект, который нанес ущерб (например, пистолет)
* @param атакующий Атакующий - это объект, который вызвал урон (например, владелец оружия)
*
* @без возврата
* /
родной rg_multidmg_apply ( const-причинитель , const-атакующий );

/ *
* Добавляет урон аккумулятору.
*
* @param inflictor Inflictor - это объект, который нанес ущерб (например, пистолет)
* @param жертва Жертва, которая получает урон
* @param flDamage Количество урона
* @param bitsDamageType Тип урона DMG_ *
*
* @без возврата
* /
native rg_multidmg_add ( const inflictor , const жертва , const Float : flDamage , const bitsDamageType );

/ *
* Выстреливает пулями из сущности.
*
* @param inflictor Inflictor - это объект, который нанес ущерб (например, пистолет)
* @param атакующий Атакующий - это объект, который нанес ущерб (например, владелец оружия)
* @param shots Количество выстрелов
* @param vecSrc Исходная позиция ствола
* @param vecDirShooting Направление съемки
* @param vecSpread Spread
* @param flDistance Макс. расстояние выстрела
* @param iBulletType Тип маркера, посмотрите перечисление с именем Bullet в cssdk_const.inc
* @param iTracerFreq Частота отслеживания
* @param iDamage Сумма урона
*
* @без возврата
* /
родной rg_fire_bullets ( const inflictor , const атакующий , const shot ,  Float : vecSrc [ 3 ],  Float : vecDirShooting [ 3 ],  Float : vecSpread [ 3 ], const Float : flDistance , const Bullet : iBulletType , const iTracerFreq , const iTracerFreq , const iTracerFreq ,

/ *
* Выпускает пули из оружия игрока.
*
* @param inflictor Inflictor - это объект, который нанес ущерб (например, пистолет)
* @param атакующий Атакующий - это объект, который нанес ущерб (например, владелец оружия)
* @param vecSrc Исходная позиция ствола
* @param vecDirShooting Направление съемки
* @param vecSpread Spread
* @param flDistance Макс. расстояние выстрела
* @param iPenetration Количество проникновения
* @param iBulletType Тип маркера, посмотрите перечисление с именем Bullet в cssdk_const.inc
* @param iDamage Сумма урона
* @param flRangeModifier Модификатор диапазона урона
* @param bPistol Пистолет выстрел
* @param shared_rand Используйте случайное начальное число игрока и получите круговой гауссовский спред
*
* @return Float: [3] Результат распространения
* /
родной Поплавок : [ 3 ]  rg_fire_bullets3 ( Const причинителя , Const взломщика ,  Float : vecSrc [ 3 ],  Float : vecDirShooting [ 3 ], Const Поплавок : vecSpread , константный Float : flDistance , константный iPenetration , константные Пули : iBulletType , Const iDamage , Const Float : flRangeModifier ,const bool : bPistol , const shared_rand );

/ *
* Заставляет раунд до конца.
*
* @param tmDelay Задержка перед началом нового раунда
* @param st Какая команда выиграла
* @param event Событие - конец раунда
* @param message Сообщение в конце раунда
* @param предложение Звук в конце раунда
* @param trigger Это сработает на все хуки этой функции
* Будьте очень осторожны с рекурсией!
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_round_end ( const Float : tmDelay , const WinStatus : st , const ScenarioEventEndRound : событие = ROUND_NONE , сообщение const []  =  "default" , предложение const []  =  "default" , const bool : trigger =  false );

/ *
* Обновляет текущие оценки.
*
* @param iCtsWins Количество побед для контртеррористов
* @param iTsWins Количество выигрышей для террористов
* @param bAdd Добавляет счет к текущей сумме
*
* @без возврата
* /
родные rg_update_teamscores ( const iCtsWins =  0 , const iTsWins =  0 , const bool : bAdd =  true );

/ *
* Создает объект, используя специальную оболочку CreateNamedEntity Counter-Strike.
*
* @param classname Entity classname
* @param useHashTable Используйте это только для известных игровых объектов
*
* @note: не используйте это, если вы используете пользовательское имя класса
*
* @return Индекс созданного объекта или 0 в противном случае
* /
native rg_create_entity ( const classname [], const bool : useHashTable =  false );

/ *
* Находит сущность в мире, используя специальную оболочку FindEntityByString Counter-Strike.
*
* @param start_index Индекс сущностей, с которого начинается поиск. -1 начать с первого лица
* @param classname Имя класса для поиска
* @param useHashTable Используйте это только для известных игровых объектов
*
* @note: не используйте это, если вы используете пользовательское имя класса
*
* @return Entity index> 0, если найден, 0 в противном случае
* /
родной rg_find_ent_by_class ( start_index , const classname [], const bool : useHashTable =  false );

/ *
* Находит сущность в мире, используя специальную оболочку FindEntityByString Counter-Strike, соответствующую владельцу.
*
* @param start_index Индекс сущностей, с которого начинается поиск. -1 начать с первого лица
* @param classname Имя класса для поиска
*
* @ возврат 1, если найден, 0 в противном случае
* /
родной rg_find_ent_by_owner (& start_index , const classname [], владелец );

/ *
* Находит оружие по имени в инвентаре игрока.
*
* @param index Клиентский индекс
* @param gun Название оружия
*
* @return Индекс сущности оружия, 0 в противном случае
* /
родной rg_find_weapon_bpack_by_name (постоянный индекс , постоянное оружие []);

/ *
* Проверяет, есть ли у игрока предмет.
*
* @param index Клиентский индекс
* @param item Название предмета
*
* @ вернет true, если он это сделает, иначе false
* /
родной bool : rg_has_item_by_name ( константный индекс , константный элемент []);

/ *
* Возвращает конкретную информацию об оружии.
*
* @param имя оружия или идентификатор оружия ID, см. WEAPON_ * константы, WeaponIdType или arms_ * имя
* @param WpnInfo: тип Info, см. WI_ * константы
*
* @return Информация об оружии
* @error Если за пределами видимости оружия или типа, будет выдано сообщение об ошибке
* /
native any : rg_get_weapon_info ( any : ...);

/ *
* Устанавливает конкретные значения информации об оружии.
*
* @param arms_id Идентификатор оружия, смотрите константы WEAPON_ *
* @param type Info type, см. константы WI_ *
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_set_weapon_info ( const { WeaponIdType , _ }: arms_id ,  WpnInfo : тип ,  любой : ...);

/ *
* Удалите все вещи игрока в определенный слот.
*
* @param index Клиентский индекс
* @param slot Слот, который будет опустошен
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_remove_items_by_slot ( const index , const InventorySlotType : slot );

/ *
* Сбросить все вещи игрока по конкретному слоту.
*
* @param index Клиентский индекс
* @param slot Специальный слот для удаления каждого предмета.
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_drop_items_by_slot ( const index , const InventorySlotType : slot );

/ *
* Удалите все предметы игрока.
*
* @param index Клиентский индекс
* @param removeSuit Удалить костюм
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_remove_all_items ( const index , const bool : removeSuit =  false );

/ *
* Заставляет игрока отказаться от указанного имени класса предмета.
*
* @param index Клиентский индекс
* @param item_name Имя класса предмета
*
* @ возврат 1 в случае успеха, 0 в противном случае
*
* /
родной rg_drop_item ( const index , const item_name []);

/ *
* Выполняет команду клиента на стороне gamedll.
*
* @param index Клиентский индекс
* @param command Клиентская команда для выполнения
* @param arg Необязательные аргументы команды
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
native rg_internal_cmd ( const index , const cmd [], const arg []  =  "" );

/ *
* Удаляет указанное имя класса предмета из плеера
*
* @param index Клиентский индекс
* @param item_name Имя класса предмета
* @param removeAmmo Удалить боеприпасы
*
* @ возврат 1, если найден и удален, 0 в противном случае
* /
родной rg_remove_item ( const index , const item_name [], const bool : removeAmmo =  false );

/ *
* Устанавливает количество патронов в рюкзаке клиента для конкретного оружия.
*
* @param index Клиентский индекс
* @param Weapon ID оружия
* @param amount Новое количество боеприпасов рюкзака, чтобы установить
*
* @без возврата
* /
родной rg_set_user_bpammo (постоянный индекс ,  WeaponIdType : оружие , количество );

/ *
* Возвращает количество патронов в рюкзаке клиента для конкретного оружия.
*
* @param index Клиентский индекс
* @param Weapon ID оружия
*
* @return Количество патронов в рюкзаке
* /
родной rg_get_user_bpammo (постоянный индекс ,  WeaponIdType : оружие );

/ *
* Устанавливает количество патронов для конкретного оружия.
*
* @param index Клиентский индекс
* @param Weapon ID оружия
* @param amount Новая сумма патронов клипа, чтобы установить
*
* @без возврата
* /
родной rg_set_user_ammo (постоянный индекс ,  WeaponIdType : оружие , количество );

/ *
* Возвращает количество патронов для конкретного оружия.
*
* @param index Клиентский индекс
* @param Weapon ID оружия
*
* @return Количество патронов
* /
родной rg_get_user_ammo (постоянный индекс ,  WeaponIdType : оружие );

/ *
* Устанавливает статус клиента defusekit и позволяет установить пользовательский значок HUD и цвет.
*
* @param index Клиентский индекс
* @param defusekit Если ненулевой клиент будет иметь defusekit, в противном случае он будет удален
* @param color Цвет RGB
* @param icon HUD sprite для использования в качестве иконки
* @param flash Если ненулевой значок будет мигать красным
*
* @без возврата
* /
native rg_give_defusekit ( const index , const bool : bDefusekit =  true , const Float : color []  =  { 0.0 ,  160.0 ,  0.0 }, const icon []  =  "defuser" , const bool : bFlash =  false );

/ *
* Возвращает значение брони клиента и получает тип брони.
*
* @param index Клиентский индекс
* @param armortype Переменная для хранения типа брони в
*
* @return Количество брони, 0, если у клиента нет брони
* /
родной rg_get_user_armor ( Const индекс ,  и ArmorType : armortype = ARMOR_NONE );

/ *
* Устанавливает значение брони клиента и тип брони.
*
* @param index Клиентский индекс
* @param armorvalue Количество брони для установки
* @param armortype Тип брони для установки
*
* @без возврата
* /
родной rg_set_user_armor ( константный индекс , значение брони ,  ArmorType : armortype );

/ *
* Устанавливает команду клиента без убийства игрока и устанавливает модель клиента.
* @note Для получения TeamName используйте следующее:
* новое TeamName: team = get_member (id, m_iTeam);
*
* @param index Клиентский индекс
* @param team ID команды
* @param model Внутренняя модель, используйте MODEL_AUTO для случайного появления или MODEL_UNASSIGNED, чтобы не обновлять ее
*
* @param send_teaminfo Если true, сообщение TeamInfo будет отправлено
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
собственный rg_set_user_team (постоянный индекс ,  { TeamName , _ }: команда ,  { ModelName , _ }: модель = MODEL_AUTO , const bool : send_teaminfo =  true );

/ *
* Устанавливает модель игрока клиента.
*
* @param index Клиентский индекс
* @param model Название модели
* @param update_index Если true, индекс модели также обновляется
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_set_user_model ( Const индекс , Const модель [], Const BOOL : update_index =  ложь );

/ *
* Сбрасывает модель клиента.
*
* @param index Клиентский индекс
* @param update_index Если true, индекс модели также сбрасывается
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_reset_user_model ( const index , const bool : update_index =  false );

/ *
* Включить / отключить шаги игрока.
*
* @param index Клиентский индекс
* @param silent Чтобы включить тихие шаги
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_set_user_footsteps (постоянный индекс ,  bool : silent =  false );

/ *
* Получить текущее состояние шагов игрока.
*
* @param index Клиентский индекс
*
* @return 1, если у игрока тихие шаги, 0 в противном случае
* /
родной rg_get_user_footsteps (постоянный индекс );

/ *
* Передача C4 от одного игрока другому.
*
* @param index Клиентский индекс
* @param receive Receiver index, если 0, он будет передан случайному игроку
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_transfer_c4 (постоянный индекс , постоянный приемник =  0 );

/ *
* Мгновенно перезагрузить клиентское оружие.
*
* @param index Клиентский индекс
* @param Weapon Entity-index, если 0, то все оружие будет перезагружено
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_instant_reload_weapons (постоянный индекс , постоянное оружие =  0 );

/ *
* Устанавливает сумму вознаграждения в игровом аккаунте для всех игроков.
*
* @param rules_index Посмотрите на перечисление с именем RewardRules
* @param amount Сумма денег
*
* @без возврата
* /
родной rg_set_account_rules ( const RewardRules : rules_index , const amount );

/ *
* Получает сумму денег указанного правила вознаграждения.
*
* @param rules_index Посмотрите на перечисление с именем RewardRules
*
* @return Размер вознаграждения
*
* /
родной rg_get_account_rules ( const RewardRules : rules_index );

/ *
* Проверяет, заложена ли бомба.
*
* @ return true если бомба заложена, иначе false
* /
родной bool : rg_is_bomb_planted ();

/ *
* Заставляет игрока присоединиться к команде.
*
* @param index Клиентский индекс
* @param team ID команды
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_join_team ( const index , const TeamName : team );

/ *
* Мгновенно балансирует команды.
*
* @без возврата
* /
родной rg_balance_teams ();

/ *
* Меняет местами команды игроков без сброса фрагов, смертей и побед.
*
* @без возврата
* /
родной rg_swap_all_players ();

/ *
* Мгновенно переключает игрока в свою противоположную команду.
* @note Переключение с CT на TERRORIST также противоположное.
*
* @param index Клиентский индекс
*
* @без возврата
* /
родной rg_switch_team (постоянный индекс );

/ *
* Заставляет игрока переключаться на конкретное оружие.
*
* @param index Клиентский индекс
* @param Weapon Weapon Entity-Index
*
* @ возврат 1 в случае успеха, 0 в противном случае
* /
родной rg_switch_weapon (постоянный индекс , постоянное оружие );

/ *
* Получает, какая команда имеет более высокий приоритет соединения.
*
* @return Возвращает название команды
* /
родной TeamName : rg_get_join_team_priority ();

/ *
* Проверяет, может ли игрок получить урон от атакующего.
*
* @param index Клиентский индекс
* @param атакующий индекс атакующего
*
* @ вернет истину, если он может получить урон, ложь в противном случае
* /
родной bool : rg_is_player_can_takedamage (постоянный индекс , постоянный атакующий );

/ *
* Получает WeaponIdType из оружия
*
* @param entity Объект Weaponbox
*
* @return возвращаемое перечисление WeaponIdType
* /
родной WeaponIdType : rg_get_weaponbox_id (постоянная сущность );

/ *
* Возрождение в раунде для игроков / ботов.
*
* @param index Клиентский индекс
*
* @без возврата
* /
родной rg_round_respawn (постоянный индекс );

/ *
* Сбрасывает максимальную скорость игрока.
*
* @param index Клиентский индекс
*
* @без возврата
* /
родной rg_reset_maxspeed (постоянный индекс );

/ *
* Рисует индикатор прогресса HUD, который заполняется от 0% до 100% за время в секундах.
* @note: установите длительность 0, чтобы скрыть панель.
*
* @param index Клиентский индекс
* @param time Duration
* @param обозреватель Отправить для всех, кто наблюдает за игроком
*
* @без возврата
* /
native rg_send_bartime ( const index , const duration , const bool : наблюдатель =  true );

/ *
* То же, что и BarTime, но StartPercent указывает, какая часть бара уже заполнена.
*
* @param index Клиентский индекс
* @param time Duration
* @param startPercent Начальный процент
* @param обозреватель Отправить для всех, кто наблюдает за игроком
*
* @без возврата
* /
родной rg_send_bartime2 ( Const индекс , Const продолжительность , Const startPercent , Const BOOL : наблюдатель =  верно );

/ *
* Отправляет сообщение SendAudio - воспроизводит указанное аудио.
*
* @param index Receiver index или используйте 0 для всех
* @param sample Звуковой файл для воспроизведения
* @param pitch Sound pitch
*
* @без возврата
* /
родной rg_send_audio (постоянный индекс , постоянный образец [], постоянная высота = PITCH_NORM );

/ * *
* Устанавливает параметр члена CSPlayerItem :: m_ItemInfo
*
* @param entity Entity index
* @param type Тип информации о предмете. Смотрите константы ItemInfo.
*
* /
родной rg_set_iteminfo (постоянная сущность ,  ItemInfo : type ,  any : ...);

/ * *
* Получает параметр члена CSPlayerItem :: m_ItemInfo
*
* @param entity Entity index
* @param type Тип информации о предмете. Смотрите константы ItemInfo.
*
* /
родной rg_get_iteminfo ( const ent ,  ItemInfo : type ,  any : ...);