# если определено _reapi_rechecker_included
	#endinput
# endif
# define  _reapi_rechecker_included

enum ResourceType
{
	RES_TYPE_NONE = 0 ,
	RES_TYPE_EXISTS,     // для сравнения с указанным значением хеша
	RES_TYPE_MISSING,    // проверяем отсутствующий файл на клиенте
	RES_TYPE_IGNORE,     // игнорируем указанное значение хеша
	RES_TYPE_HASH_ANY,   // любой файл с любым значением хеша
};

enum ReCheckerFunc
{
	/ *
	* Описание: -
	* Params: (const client, const filename [], const cmd [], const ResourceType: type, const responseHash, bool: isBreak)
	* /
	RC_FileConsistencyProcess = BEGIN_FUNC_REGION (перепроверщик),

	/ *
	* Описание: -
	* Параметры: (постоянный клиент)
	* /
	RC_FileConsistencyFinal,

	/ *
	* Описание: -
	* Params: (const client, const filename [], const cmd [], const responseHash)
	* /
	RC_CmdExec,

	// [...]
};

/ *
* Отправить запрос на файл для клиента, чтобы получить хэш
*
* @param file Файл (может содержать относительный путь к файлу)
* @param function Переадресация вызова
* @param type Тип запроса может быть только RES_TYPE_EXISTS, RES_TYPE_MISSING или RES_TYPE_HASH_ANY
* @param hash Хэш файла для запроса.
*
* @return Возвращает дескриптор крюка. Используйте UnRegisterQueryFile, чтобы удалить форвард
* /
нативный QueryFileHook: RegisterQueryFile ( const file [], const function [], const ResourceType: type, const hash = - 1 );

/ *
* Отменить регистрацию форварда.
* Используйте возвращаемое значение из RegisterQueryFile в качестве параметра здесь!
*
* @param hook Крючок для удаления
*
* @return Возвращает true, если хук успешно удален, иначе false
* /
родной bool : UnRegisterQueryFile (QueryFileHook: hook);