#include <amxmodx>
#include <amxmisc>
#include <hamsandwich>
#include <cstrike>
#include <dhudmessage>

new g_LoadList[81]
new iPlayerBlock[33]

native jbe_get_user_team(pPlayer)
native jbe_set_user_team(pPlayer, iTeam)
native jbe_chat_prefix(str[], len);


public plugin_init()
{
	register_plugin("[JBE] Block", "2.0", "LeGioN")

	RegisterHam(Ham_Spawn, "player", "PlayerSpawn", 1)

	register_clcmd("block", "BlockMenu")
	register_clcmd("unblock", "UnblockMenu")
	register_dictionary("jbe_core.txt")
}

public plugin_cfg()
{
	new g_LoadDir[81]
	get_configsdir(g_LoadDir, charsmax(g_LoadDir))

	formatex(g_LoadList, charsmax(g_LoadList), "%s/jbe_save/jbe_block_ct.ini", g_LoadDir)
}

public client_authorized(id)
{
	if(!is_user_bot(id) || !is_user_hltv(id))
	{
		set_task(0.1, "CheckPlayer", id)
	}
}

public plugin_natives() register_native("block_info", "block_info", 1)
public block_info(id) return iPlayerBlock[id]
public client_disconnect(id) iPlayerBlock[id] = false

public CheckPlayer(id)
{
	new szName[64], szSteam[32]
	new szParse[128]
	new iLine, iNum

	get_user_name(id, szName, charsmax(szName))
	get_user_authid(id, szSteam, charsmax(szSteam))

	for(iLine = 0; read_file(g_LoadList, iLine, szParse, charsmax(szParse), iNum); iLine++) 
	{
		if(iNum > 0 && szParse[0] != ';')
		{
			if(equal(szName, szParse) || equal(szSteam, szParse))
			{
				iPlayerBlock[id] = true
				break
			}
		}
	}
}


public PlayerSpawn(id)
{
	if(!is_user_alive(id) || !is_user_connected(id)) return PLUGIN_CONTINUE
	if(!iPlayerBlock[id]) return PLUGIN_CONTINUE
	new quests_str[64];
	jbe_chat_prefix(quests_str, charsmax(quests_str));
	if(jbe_get_user_team(id) == 2)
	{
		jbe_set_user_team(id, 1)
		ChatColor(id, "%s !yВам заблокирован вход за !tохранников!g!", quests_str)
	}
	return PLUGIN_CONTINUE
}

public BlockMenu(id)
{
	if(!(get_user_flags(id) & ADMIN_BAN)) return PLUGIN_HANDLED

	new szTitle[512]

	formatex(szTitle, charsmax(szTitle), "\d[\yX\d] Управление Охраной")
	new iMenu = menu_create(szTitle, "BlockMenu_handler")

	new iPlayers[32], szName[32]
	new iPlayer, iNum, iNumCT, iPlayerNum[10]
	new quests_str[64];
	jbe_chat_prefix(quests_str, charsmax(quests_str));

	get_players(iPlayers, iNum)

	for(new i; i < iNum; i++)
	{
		iPlayer = iPlayers[i]

		if(!is_user_connected(iPlayer) || iPlayer == id || iPlayerBlock[iPlayer] || jbe_get_user_team(iPlayer) != 2)
			continue

		get_user_name(iPlayer, szName, charsmax( szName ))
		num_to_str(iPlayer, iPlayerNum, charsmax( iPlayerNum ))

		if(get_user_flags(iPlayer) & ADMIN_RCON)
		{
			menu_additem(iMenu, szName, iPlayerNum, ADMIN_ADMIN)
		}
		else
		{
			menu_additem(iMenu, szName, iPlayerNum, 0)
		}
		++iNumCT
	}

	if(!iNumCT)
	{
		ChatColor(id, "%s !yОтсутствуют !tохранники", quests_str)
		return PLUGIN_HANDLED
	}

	menu_setprop(iMenu, MPROP_EXIT, MEXIT_ALL )
	menu_setprop(iMenu, MPROP_NEXTNAME, "Далее")
	menu_setprop(iMenu, MPROP_BACKNAME, "Назад")
	menu_setprop(iMenu, MPROP_EXITNAME, "Выход")

	menu_display(id, iMenu, 0)
	return PLUGIN_HANDLED
}

public BlockMenu_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy( iMenu )
		return PLUGIN_HANDLED
	}

	new szData[6], szName[64], szAccess, szCallback
	menu_item_getinfo(iMenu, iItem, szAccess, szData, charsmax( szData ), szName, charsmax( szName ), szCallback)

	new iPlayer = str_to_num( szData )

	new szText[512], AzName[512], text[124]
	new szNamePlayer[32], szSteamPlayer[32]
	
	new CurrentTime[128], sTime[128] 
	get_time("%d,%m,%Y | %X", CurrentTime, 31);
	format(sTime, charsmax(sTime), "Дата: %s", CurrentTime, 32);

	get_user_name(iPlayer, szNamePlayer, charsmax( szNamePlayer ))
	get_user_authid(iPlayer, szSteamPlayer, charsmax( szSteamPlayer ))

	iPlayerBlock[iPlayer] = true

	jbe_set_user_team(iPlayer, 1)
	ExecuteHam(Ham_CS_RoundRespawn, iPlayer)
	
	formatex(text, charsmax(text), "#################[ Новый блок ]#################")
	formatex(AzName, charsmax(AzName), "#[ Ник: %s | %s ]#", szNamePlayer, sTime)
	formatex(szText, charsmax(szText), "%s", szSteamPlayer)
	write_file(g_LoadList, text, -1)
	write_file(g_LoadList, AzName, -1)
	write_file(g_LoadList, szText, -1)
	new quests_str[64];
	jbe_chat_prefix(quests_str, charsmax(quests_str));
	
	ChatColor(0, "%s !yИгроку !t%s !yзаблокирован вход за !tохранников!g!!", quests_str, szNamePlayer)

	menu_destroy( iMenu )	
	return PLUGIN_HANDLED
}

public UnblockMenu(id)
{
	if(!(get_user_flags(id) & ADMIN_BAN)) return PLUGIN_HANDLED

	new szTitle[512]

	formatex(szTitle, charsmax( szTitle ), "\d[\yX\d] Управление охраной")
	new iMenu = menu_create(szTitle, "UnblockMenu_handler")

	new iPlayers[32], szName[32]
	new iPlayer, iNum, iNumBlock, iPlayerNum[10]
	new quests_str[64];
	jbe_chat_prefix(quests_str, charsmax(quests_str));
	get_players(iPlayers, iNum)

	for(new i; i < iNum; i++)
	{
		iPlayer = iPlayers[i]

		if(!is_user_connected( iPlayer ) || iPlayer == id || !iPlayerBlock[iPlayer])
			continue

		get_user_name(iPlayer, szName, charsmax( szName ))
		num_to_str(iPlayer, iPlayerNum, charsmax( iPlayerNum ))

		menu_additem(iMenu, szName, iPlayerNum, 0)
		++iNumBlock
	}

	if(!iNumBlock)
	{
		ChatColor(id, "%s !yОтсутствуют !tохранники!", quests_str)
		return PLUGIN_HANDLED
	}

	menu_setprop(iMenu, MPROP_EXIT, MEXIT_ALL )
	menu_setprop(iMenu, MPROP_NEXTNAME, "Далее")
	menu_setprop(iMenu, MPROP_BACKNAME, "Назад")
	menu_setprop(iMenu, MPROP_EXITNAME, "Выход")

	menu_display(id, iMenu, 0)
	return PLUGIN_HANDLED
}

public UnblockMenu_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy( iMenu )
		return PLUGIN_HANDLED
	}

	new szData[6], szName[64], szAccess, szCallback
	menu_item_getinfo(iMenu, iItem, szAccess, szData, charsmax( szData ), szName, charsmax( szName ), szCallback)

	new iPlayer = str_to_num( szData )

	new szText[512] 
	new szNamePlayer[32], szSteamPlayer[32]
	new szParse[128]
	new iLine, iNum

	get_user_name(iPlayer, szNamePlayer, charsmax( szNamePlayer ))
	get_user_authid(iPlayer, szSteamPlayer, charsmax( szSteamPlayer ))

	iPlayerBlock[iPlayer] = false

	for(iLine = 0; read_file(g_LoadList, iLine, szParse, charsmax( szParse ), iNum); iLine++) 
	{
		if(iNum > 0 && szParse[0] != ';')
		{
			if(equal(szNamePlayer, szParse))
			{
				formatex(szText, charsmax(szText), ";%s", szNamePlayer)
				write_file(g_LoadList, szText, iLine)

				break
			}
			else if(equal(szSteamPlayer, szParse))
			{
				formatex(szText, charsmax(szText), ";%s", szSteamPlayer)
				write_file(g_LoadList, szText, iLine)

				break
			}
		}
	}
	new quests_str[64];
	jbe_chat_prefix(quests_str, charsmax(quests_str));
	ChatColor(0, "%s !yИгроку !t%s !yразблокирован вход за !tохранников!", quests_str, szNamePlayer)
	menu_destroy(iMenu)
	return PLUGIN_HANDLED
}

stock ChatColor(const id, const input[], any:...)
{
	new count = 1, players[32]
	static msg[191] 
	vformat(msg, 190, input, 3)
	
	replace_all(msg, 190, "!g", "^4")
	replace_all(msg, 190, "!y", "^1")
	replace_all(msg, 190, "!t", "^3")
	
	if (id) players[0] = id; else get_players(players, count, "ch")
	{
		for (new i = 0; i < count; i++)
		{
			if (is_user_connected(players[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i]);
				write_byte(players[i]);
				write_string(msg);
				message_end();
			}
		}
	}
}