#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <engine>
#include <jbe_core>

#pragma semicolon 1

#define MAX_PLAYERS 32
#define is_valid_pev(%0) (pev_valid(%0) == 2)
#define get_weapon_skin(%0) pev(%0, pev_iuser4)
#define set_weapon_skin(%0,%1) set_pev(%0, pev_iuser4, %1)

enum _:DATA_SKIN_INFO
{
	WEAPON_ID[16],
	SKIN_NAME[32],
	V_MODEL[64],
	P_MODEL[64],
	W_MODEL[64],
	FLAG[2],
	WEAPON_CSW
};
new Array:g_aWeaponSkins, g_LoadedWeapons, g_iWeaponSkinsCount, g_iPlayerSkins[MAX_PLAYERS + 1][32];

// Построение меню из игроков
new g_iMenuPosition[MAX_PLAYERS + 1];

public plugin_init()
{
	register_plugin("[JBE] GuardWeapon", "1.0", "Mistrik & AlexandrFiner");
	register_menucmd(register_menuid("Show_WeaponsGuardMenu"), (1<<0|1<<1|1<<2|1<<3|1<<4|1<<5|1<<6|1<<7|1<<8|1<<9), "Handle_WeaponsGuardMenu");
	
	RegisterWeapons();
	RegisterWeaponDrop();
}
  
public plugin_natives() 				{ register_native("jbe_open_guard_weapon_menu", "jbe_open_guard_weapon_menu", 1); }
public jbe_open_guard_weapon_menu(id) 	{ return Cmd_WeaponsGuardMenu(id); }
public client_putinserver(id) 			{ arrayset(g_iPlayerSkins[id], 0, sizeof(g_iPlayerSkins[])); }

public plugin_precache()
{
	new szCfgDir[64], szCfgFile[128]; 
	get_localinfo("amxx_configsdir", szCfgDir, charsmax(szCfgDir));
	formatex(szCfgFile, charsmax(szCfgFile), "%s/jb_engine/weapons_guard.ini", szCfgDir);
	new file = fopen(szCfgFile, "rt");
	if(!file)
	{
		new error[100];
		formatex(error, charsmax(error), "[JBE] Отсутсвтует: %s!", szCfgFile);
		set_fail_state(error);
		return;
	}
	g_aWeaponSkins = ArrayCreate(DATA_SKIN_INFO, 1);
	new szBuffer[512], g_iWeaponID, aDataSkinInfo[DATA_SKIN_INFO];
	while(!feof(file))
	{
		fgets(file, szBuffer, charsmax(szBuffer));
		if(!szBuffer[0] || szBuffer[0] == ';' || szBuffer[0] == '#') continue;
		parse(szBuffer, 
		aDataSkinInfo[WEAPON_ID],	charsmax(aDataSkinInfo[WEAPON_ID]), 
		aDataSkinInfo[SKIN_NAME],	charsmax(aDataSkinInfo[SKIN_NAME]), 
		aDataSkinInfo[V_MODEL],		charsmax(aDataSkinInfo[V_MODEL]), 
		aDataSkinInfo[P_MODEL],		charsmax(aDataSkinInfo[P_MODEL]), 
		aDataSkinInfo[W_MODEL],		charsmax(aDataSkinInfo[W_MODEL]), 
		aDataSkinInfo[FLAG],		charsmax(aDataSkinInfo[FLAG]));
		
		g_iWeaponID = get_weapon_csw(aDataSkinInfo[WEAPON_ID]);
		if(!g_iWeaponID) continue;
		aDataSkinInfo[WEAPON_CSW] = g_iWeaponID;
		g_LoadedWeapons |= (1<<g_iWeaponID);
		
		if(file_exists(aDataSkinInfo[V_MODEL])) { precache_model(aDataSkinInfo[V_MODEL]); aDataSkinInfo[V_MODEL] = engfunc(EngFunc_AllocString, aDataSkinInfo[V_MODEL]); }
		if(file_exists(aDataSkinInfo[P_MODEL])) { precache_model(aDataSkinInfo[P_MODEL]); aDataSkinInfo[P_MODEL] = engfunc(EngFunc_AllocString, aDataSkinInfo[P_MODEL]); }
		if(file_exists(aDataSkinInfo[W_MODEL])) { precache_model(aDataSkinInfo[W_MODEL]); }
		
		ArrayPushArray(g_aWeaponSkins, aDataSkinInfo);
		g_iWeaponSkinsCount++;
		aDataSkinInfo[V_MODEL] = 0; aDataSkinInfo[P_MODEL] = 0; aDataSkinInfo[W_MODEL] = 0;
	}
	fclose(file);
	if(!g_iWeaponSkinsCount || g_iWeaponSkinsCount > 9)
	{
		ArrayDestroy(g_aWeaponSkins);
		set_fail_state("[JBE Weapons] ERROR");
	}
}

Cmd_WeaponsGuardMenu(id) return Show_WeaponsGuardMenu(id, g_iMenuPosition[id] = 0);
Show_WeaponsGuardMenu(id, iPos)
{
	if(jbe_get_day_mode() != 1 && jbe_get_day_mode() != 2 || !is_user_alive(id) || iPos < 0) return PLUGIN_HANDLED;
	new szMenu[512], iLen;
	new iKeys = (1<<9), b;
	iLen = formatex(szMenu, charsmax(szMenu), "\d[\r&\d]\d Оружейка^n^n");
	for(new a; a < g_iWeaponSkinsCount; a++)
	{
		new aDataSkinInfo[DATA_SKIN_INFO];
		ArrayGetArray(g_aWeaponSkins, a, aDataSkinInfo);
		if(!aDataSkinInfo[FLAG] || get_user_flags(id) & read_flags(aDataSkinInfo[FLAG]))
		{
			iKeys |= (1<<b);
			iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r%d\d] \w%s^n", ++b, aDataSkinInfo[SKIN_NAME]);
		}
		else iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r%d\d] \d%s \r[Нет доступа]^n", ++b, aDataSkinInfo[SKIN_NAME]);
	}
	for(new i = b; i < 9; i++) iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n");
	formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n\d[\r0\d] \wВыход");
	return show_menu(id, iKeys, szMenu, -1, "Show_WeaponsGuardMenu");
}

public Handle_WeaponsGuardMenu(id, iKey)
{
	if(jbe_get_day_mode() != 1 && jbe_get_day_mode() != 2 || !is_user_alive(id)) return PLUGIN_HANDLED;
	switch(iKey)
	{
		case 9: return PLUGIN_HANDLED;
		default:
		{
			new aDataSkinInfo[DATA_SKIN_INFO];
			ArrayGetArray(g_aWeaponSkins, iKey, aDataSkinInfo);
			drop_user_weapons(id, 0);
			fm_give_item(id, aDataSkinInfo[WEAPON_ID]);
			fm_set_user_bpammo(id, aDataSkinInfo[WEAPON_CSW], 1000);
			drop_user_weapons(id, 1);
			fm_give_item(id, "weapon_deagle");
			fm_set_user_bpammo(id, CSW_DEAGLE, 1000);
			g_iPlayerSkins[id][aDataSkinInfo[WEAPON_CSW]] = iKey + 1;
			new weapon, weaponid;
			new cur_weapon = get_pdata_cbase(id, 373, 5);
			for(new i; i < 6; i++)
			{
				weapon = get_pdata_cbase(id, 367 + i, 5);
				while (is_valid_pev(weapon))
				{
					weaponid = get_pdata_int(weapon, 43, 4);
					if(weaponid == aDataSkinInfo[WEAPON_CSW])
					{
						set_weapon_skin(weapon, iKey + 1);
						if(weapon == cur_weapon)
						{
							if(aDataSkinInfo[V_MODEL]) set_pev(id, pev_viewmodel, aDataSkinInfo[V_MODEL]);
							if(aDataSkinInfo[P_MODEL]) set_pev(id, pev_weaponmodel, aDataSkinInfo[P_MODEL]);
						}
						i = 6; break;
					}
					weapon = get_pdata_cbase(weapon, 42, 4);
				}
			}
		}
	}
	return PLUGIN_HANDLED;
}

enum
{
	ADD_BY_WEAPONBOX,
	ADD_BY_ARMORY_ENTITY,
	ADD_BY_BUYZONE
}

new Float:g_flLastTouchTime;
new bool:g_bIgnoreSetModel = true;

RegisterWeapons()
{
	for(new i = CSW_P228, weapon_name[32]; i < CSW_P90; i++)
	{
		if(get_weaponname(i, weapon_name, charsmax(weapon_name)))
		{
			RegisterHam(Ham_Item_Deploy, weapon_name, "Ham_WeaponDeploy_Post", .Post = true);
			RegisterHam(Ham_Item_AddToPlayer, weapon_name, "Ham_WeaponAddToPlayer_Post", .Post = true);
		}
	}
	register_touch("armoury_entity", "player", "CArmouryEntity__Touch");
}
RegisterWeaponDrop()
{
	RegisterHam(Ham_Spawn, "grenade", "Ham_WeaponSpawn_Post", true);
	RegisterHam(Ham_Spawn, "player", "Ham_WeaponSpawn_Post_pPlayer", true);
	RegisterHam(Ham_Spawn, "weaponbox", "Ham_WeaponSpawn_Post", true);
	register_forward(FM_SetModel, "FM_SetModel_Pre", false);
}

public Ham_WeaponDeploy_Post(const weapon)
{
	new id = get_pdata_cbase(weapon, 41, 4);
	new iSkin = get_weapon_skin(weapon);
	if(iSkin)
	{
		new aDataSkinInfo[DATA_SKIN_INFO];
		ArrayGetArray(g_aWeaponSkins, iSkin - 1, aDataSkinInfo);
		if(aDataSkinInfo[V_MODEL]) set_pev(id, pev_viewmodel, aDataSkinInfo[V_MODEL]);
		if(aDataSkinInfo[P_MODEL]) set_pev(id, pev_weaponmodel, aDataSkinInfo[P_MODEL]);
	}
}

public CArmouryEntity__Touch(ent, id)
{
    g_flLastTouchTime = get_gametime();
}

public Ham_WeaponAddToPlayer_Post(const weapon, const id)
{
	new weaponid = get_pdata_int(weapon, 43, 4);
	new type;
	if (pev(weapon, pev_owner) > 0) type = ADD_BY_WEAPONBOX;
	else if(get_gametime() == g_flLastTouchTime) type = ADD_BY_ARMORY_ENTITY;
	else type = ADD_BY_BUYZONE;
	
	if(type == ADD_BY_ARMORY_ENTITY || type == ADD_BY_WEAPONBOX) return 0;
	if(get_weapon_skin(weapon)) return 0;
	if(g_iPlayerSkins[id][weaponid]) set_weapon_skin(weapon, g_iPlayerSkins[id][weaponid]);
	return 0;
}

public Ham_WeaponSpawn_Post(const ent) if (is_valid_pev(ent)) g_bIgnoreSetModel = false;
public Ham_WeaponSpawn_Post_pPlayer(pPlayer) 
{
	if(is_user_alive(pPlayer))
	{
		arrayset(g_iPlayerSkins[pPlayer], 0, sizeof(g_iPlayerSkins[]));
	}
}
public FM_SetModel_Pre(const ent)
{
	if(g_bIgnoreSetModel || !is_valid_pev(ent)) return FMRES_IGNORED;
	g_bIgnoreSetModel = true;
	new classname[32]; pev(ent, pev_classname, classname, charsmax(classname));
	if(equal(classname, "grenade"))
	{
		new iSkin = get_weapon_skin(0);
		if(iSkin)
		{
			new aDataSkinInfo[DATA_SKIN_INFO];
			ArrayGetArray(g_aWeaponSkins, iSkin - 1, aDataSkinInfo);
			if(aDataSkinInfo[W_MODEL]) 
			{
				engfunc(EngFunc_SetModel, ent, aDataSkinInfo[W_MODEL]);
				return FMRES_SUPERCEDE;
			}
			return FMRES_IGNORED;
		}
		return FMRES_IGNORED;
	}
	#define MAX_ITEM_TYPES	6
	for(new i, weapon; i < MAX_ITEM_TYPES; i++)
	{
		weapon = get_pdata_cbase(ent, 34 + i, 4);

		if(is_valid_pev(weapon))
		{
			new iSkin = get_weapon_skin(weapon);
			if(iSkin)
			{
				new aDataSkinInfo[DATA_SKIN_INFO];
				ArrayGetArray(g_aWeaponSkins, iSkin - 1, aDataSkinInfo);
				if(aDataSkinInfo[W_MODEL]) 
				{
					engfunc(EngFunc_SetModel, ent, aDataSkinInfo[W_MODEL]);
					return FMRES_SUPERCEDE;
				}
				return FMRES_IGNORED;
			}
			return FMRES_IGNORED;
		}
	}
	
	return FMRES_IGNORED;
}

/* Stock */
stock fm_set_user_bpammo(pPlayer, iWeaponId, iAmount)
{
	new iOffset;
	switch(iWeaponId)
	{
		case CSW_AWP: iOffset = 377; // ammo_338magnum
		case CSW_SCOUT, CSW_AK47, CSW_G3SG1: iOffset = 378; // ammo_762nato
		case CSW_M249: iOffset = 379; // ammo_556natobox
		case CSW_FAMAS, CSW_M4A1, CSW_AUG, CSW_SG550, CSW_GALI, CSW_SG552: iOffset = 380; // ammo_556nato
		case CSW_M3, CSW_XM1014: iOffset = 381; // ammo_buckshot
		case CSW_USP, CSW_UMP45, CSW_MAC10: iOffset = 382; // ammo_45acp
		case CSW_FIVESEVEN, CSW_P90: iOffset = 383; // ammo_57mm
		case CSW_DEAGLE: iOffset = 384; // ammo_50ae
		case CSW_P228: iOffset = 385; // ammo_357sig
		case CSW_GLOCK18, CSW_MP5NAVY, CSW_TMP, CSW_ELITE: iOffset = 386; // ammo_9mm
		case CSW_FLASHBANG: iOffset = 387;
		case CSW_HEGRENADE: iOffset = 388;
		case CSW_SMOKEGRENADE: iOffset = 389;
		case CSW_C4: iOffset = 390;
		default: return;
	}
	set_pdata_int(pPlayer, iOffset, iAmount, 5);
}

stock drop_user_weapons(pPlayer, iType)
{
	new iWeaponsId[32], iNum;
	get_user_weapons(pPlayer, iWeaponsId, iNum);
	if(iType) iType = (1<<CSW_GLOCK18|1<<CSW_USP|1<<CSW_P228|1<<CSW_DEAGLE|1<<CSW_ELITE|1<<CSW_FIVESEVEN);
	else iType = (1<<CSW_M3|1<<CSW_XM1014|1<<CSW_MAC10|1<<CSW_TMP|1<<CSW_MP5NAVY|1<<CSW_UMP45|1<<CSW_P90|1<<CSW_GALIL|1<<CSW_FAMAS|1<<CSW_AK47|1<<CSW_M4A1|1<<CSW_SCOUT|1<<CSW_SG552|1<<CSW_AUG|1<<CSW_AWP|1<<CSW_G3SG1|1<<CSW_SG550|1<<CSW_M249);
	for(new i; i < iNum; i++)
	{
		if(iType & (1<<iWeaponsId[i]))
		{
			new szWeaponName[24];
			get_weaponname(iWeaponsId[i], szWeaponName, charsmax(szWeaponName));
			engclient_cmd(pPlayer, "drop", szWeaponName);
		}
	}
}

stock fm_cs_get_grenade_type(index)
{
	const m_iTeam = 114;
	new bits = get_pdata_int(index, m_iTeam);

	if (bits & (1 << 0))
		return CSW_HEGRENADE;
	else if (bits & (1 << 1))
		return CSW_SMOKEGRENADE;
	else if (!bits)
		return CSW_FLASHBANG;

	return 0;
}

stock fm_give_item(pPlayer, const szItem[])
{
	new iEntity = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, szItem));
	if(!pev_valid(iEntity)) return 0;
	new Float:vecOrigin[3];
	pev(pPlayer, pev_origin, vecOrigin);
	set_pev(iEntity, pev_origin, vecOrigin);
	set_pev(iEntity, pev_spawnflags, pev(iEntity, pev_spawnflags) | SF_NORESPAWN);
	dllfunc(DLLFunc_Spawn, iEntity);
	dllfunc(DLLFunc_Touch, iEntity, pPlayer);
	if(pev(iEntity, pev_solid) != SOLID_NOT)
	{
		engfunc(EngFunc_RemoveEntity, iEntity);
		return -1;
	}
	return iEntity;
}

stock get_weapon_csw(szWeapon[])
{
	static g_iWeapon[][] = 
	{
		"", "weapon_p228", "weapon_shield", "weapon_scout", "weapon_hegrenade", "weapon_xm1014", "weapon_c4",
		"weapon_mac10", "weapon_aug", "weapon_smokegrenade", "weapon_elite", "weapon_fiveseven", "weapon_ump45",
		"weapon_sg550", "weapon_galil", "weapon_famas", "weapon_usp", "weapon_glock18", "weapon_awp", "weapon_mp5navy",
		"weapon_m249", "weapon_m3", "weapon_m4a1", "weapon_tmp", "weapon_g3sg1", "weapon_flashbang", "weapon_deagle",
		"weapon_sg552", "weapon_ak47", "weapon_knife", "weapon_p90"
	};
	for(new i = 1; i < sizeof(g_iWeapon); i++) if(equali(szWeapon, g_iWeapon[i])) return i;
	return 0;
}