#include 		AMXMODX			// Главный модуль
#include 		fakemeta		// Форварды, engfunc и другое
#include		jbe_core

// Простые настройки
#define TIME_TO_START 300.0
#define TIMER 60

// Проверка на ;
#pragma semicolon 1

// Задачи
#define TASK_COUNT_DOWN 196681

enum _:DATA_QUEST
{
	QUEST_TEXT[64],
	QUEST_ANSWER[64],
	QUEST_PRIZE[16]
}
new Array:g_aQuestList;
new g_iQuestListSize;

new g_iSyncMainInformer;
new g_iCountDown;
new g_iAnswer[64], g_szMath[196], g_iPrize;
new g_iMaxPlayers;

public plugin_init()
{
	register_plugin("[JBM] Quests", "1.2",	"LeGioN");
	
// команды
	register_clcmd("say",					"Command_HookSay");
	register_clcmd("say_team",				"Command_HookSay");
	
// Информер
	g_iSyncMainInformer 					= CreateHudSyncObj();
	
// Таск
	set_task(TIME_TO_START, 				"jbe_CreateQuest");
// Для чата
	g_iMaxPlayers 							= get_maxplayers();
	register_dictionary("jbe_core.txt");
}

public plugin_cfg()
{
	new szCfgDir[64], szCfgFile[128];
	get_localinfo("amxx_configsdir", szCfgDir, charsmax(szCfgDir));
	formatex(szCfgFile, charsmax(szCfgFile), "%s/jb_engine/quests.ini", szCfgDir);
	if(!file_exists(szCfgFile))
	{
		new error[100];
		formatex(error, charsmax(error), "[JBM] Отсутсвтует: %s!", szCfgFile);
		set_fail_state(error);
		return;
	}
	new szBuffer[128];
	new aDataQuestRead[DATA_QUEST];
	g_aQuestList = ArrayCreate(DATA_QUEST);
	new file = fopen(szCfgFile, "rt");
	while(file && !feof(file))
	{ 
		fgets(file, szBuffer, charsmax(szBuffer));
		if(szBuffer[0] == ';' || szBuffer[0] == '#') continue;
		parse
		(
			szBuffer, 
			aDataQuestRead[QUEST_TEXT],				charsmax(aDataQuestRead[QUEST_TEXT]), 
			aDataQuestRead[QUEST_ANSWER],			charsmax(aDataQuestRead[QUEST_ANSWER]),
			aDataQuestRead[QUEST_PRIZE],			charsmax(aDataQuestRead[QUEST_PRIZE])
		);
		if(!aDataQuestRead[QUEST_TEXT]) continue;
		ArrayPushArray(g_aQuestList, aDataQuestRead);
	}
	g_iQuestListSize = ArraySize(g_aQuestList);
	fclose(file);
}

public Command_HookSay(id)
{
	new szChat[228];
	read_args(szChat, charsmax(szChat));
	remove_quotes(szChat);
	strtolower(szChat);
	if(equali(szChat, g_iAnswer) && task_exists(TASK_COUNT_DOWN))
	{
		if(task_exists(TASK_COUNT_DOWN)) remove_task(TASK_COUNT_DOWN);
		if(!is_user_connected(id)) return PLUGIN_CONTINUE; 
		
	// Выдаем награду
		jbe_set_user_money(id, jbe_get_user_money(id) + g_iPrize, 1);
		
		new szName[32];
		get_user_name(id, szName, charsmax(szName));
		
	// Показываем информер
		set_hudmessage(random_num(100,255), random_num(100,255), random_num(100,255), -1.0, 0.02, 0, 0.0, 0.9, 0.1, 0.1, -1);
		ShowSyncHudMsg(0, g_iSyncMainInformer, "Игрок %s нашел ответ на вопрос!^nПриз: %d$^nОтвет был: %s", szName, g_iPrize, g_iAnswer);
			
	// Производим звук
	// Пишем в чат
		UTIL_SayText(0, "%L Игрок !g%s !yнашел ответ на вопрос и получил !t%d$!y. Ответ: !g%s", LANG_PLAYER, "JBE_PREFIX", szName, g_iPrize, g_iAnswer);
		
	// Перезапуск задачи
		set_task(TIME_TO_START, "jbe_CreateQuest");
	}
	return PLUGIN_CONTINUE;
}

public jbe_CreateQuest()
{
	new aDataQuestRead[DATA_QUEST]; 
	new iMath = random_num(0, g_iQuestListSize - 1);
	ArrayGetArray(g_aQuestList, iMath, aDataQuestRead);
	
	formatex(g_iAnswer, charsmax(g_iAnswer), "%s", aDataQuestRead[QUEST_ANSWER]);
	formatex(g_szMath, charsmax(g_szMath), "%s", aDataQuestRead[QUEST_TEXT]);
	g_iPrize = str_to_num(aDataQuestRead[QUEST_PRIZE]);
	
	set_task(1.0, "jbe_QuestInformer", TASK_COUNT_DOWN, _, _, "a", g_iCountDown = TIMER + 1);
}

public jbe_QuestInformer()
{
	if(--g_iCountDown)
	{
		set_hudmessage(random_num(100,255), random_num(100,255), random_num(100,255), -1.0, 0.02, 0, 0.0, 0.9, 0.1, 0.1, -1);
		ShowSyncHudMsg(0, g_iSyncMainInformer, "Вопрос: %s^nОсталось на ответ: %d сек^nПиши в чат с большой буквы", g_szMath, g_iCountDown);
	}
	else if(g_iCountDown == 0)
	{
		g_iCountDown = 0;
		set_task(TIME_TO_START, "jbe_CreateQuest");
		UTIL_SayText(0, "%L Никто не смог дать ответ на вопрос. Ответ: !gГуглите!!y.", LANG_PLAYER, "JBE_PREFIX");
	}
}

stock UTIL_SayText(pPlayer, const szMessage[], any:...)
{
	new szBuffer[190];
	if(numargs() > 2) vformat(szBuffer, charsmax(szBuffer), szMessage, 3);
	else copy(szBuffer, charsmax(szBuffer), szMessage);
	while(replace(szBuffer, charsmax(szBuffer), "!y", "^1")) {}
	while(replace(szBuffer, charsmax(szBuffer), "!t", "^3")) {}
	while(replace(szBuffer, charsmax(szBuffer), "!g", "^4")) {}
	switch(pPlayer)
	{
		case 0:
		{
			for(new iPlayer = 1; iPlayer <= g_iMaxPlayers; iPlayer++)
			{
				if(!is_user_connected(iPlayer)) continue;
				engfunc(EngFunc_MessageBegin, MSG_ONE_UNRELIABLE, 76, {0.0, 0.0, 0.0}, iPlayer);
				write_byte(iPlayer);
				write_string(szBuffer);
				message_end();
			}
		}
		default:
		{
			engfunc(EngFunc_MessageBegin, MSG_ONE_UNRELIABLE, 76, {0.0, 0.0, 0.0}, pPlayer);
			write_byte(pPlayer);
			write_string(szBuffer);
			message_end();
		}
	}
}