#include <amxmodx>
#include <fakemeta>
#include <dhudmessage>

#define MsgId_SayText 76

#define REKLAMA_CHAT 0
#define REKLAMA_HUD 1
#define REKLAMA_CMD 2

new const g_iColorsHud[][] = { { 0, 255, 0 }, { 255, 255, 0 }, { 0, 255, 255 }, { 255, 0, 255 }, { 255, 100, 0 }, { 120, 255, 0 }, { 0, 255, 120 }, 
{ 50, 150, 250 }, { 255, 0, 145 }, { 0, 0, 255 } };

new Array:g_aDataReklama[3], Trie:g_tCommand, g_iReklamaListSize[3], g_iReklamaNext[2], g_iMaxPlayers;

public plugin_init()
{
	register_plugin("***[DEAD]~[RECLAMA]***", "1.0", "[VaMpIr] DEAD");
	register_clcmd("say", "ClCmd_Say");
	register_clcmd("say_team", "ClCmd_Say");
	g_iMaxPlayers = get_maxplayers();
	set_task(10.0, "Task_CheckFile");
}

public Task_CheckFile()
{
	new szCfgDir[64], szCfgFile[128];
	get_localinfo("amxx_configsdir", szCfgDir, charsmax(szCfgDir));
	formatex(szCfgFile, charsmax(szCfgFile), "%s/advertising.ini", szCfgDir);
	switch(file_exists(szCfgFile))
	{
		case 0: log_to_file("%s/reklama_error.log", "File ^"%s^" not found!", szCfgDir, szCfgFile);
		case 1:
		{
			g_aDataReklama[REKLAMA_CHAT] = ArrayCreate(256);
			g_aDataReklama[REKLAMA_HUD] = ArrayCreate(256);
			g_aDataReklama[REKLAMA_CMD] = ArrayCreate(256);
			g_tCommand = TrieCreate();
			new szBuffer[290], iLine, iLen, szType[2], szText[256], szCommand[32];
			while(read_file(szCfgFile, iLine++, szBuffer, charsmax(szBuffer), iLen))
			{
				if(!iLen || szBuffer[0] == ';') continue;
				parse(szBuffer, szType, charsmax(szType), szText, charsmax(szText), szCommand, charsmax(szCommand));
				switch(szType[0])
				{
					case '0':
					{
						ArrayPushString(g_aDataReklama[REKLAMA_CHAT], szText);
						g_iReklamaListSize[REKLAMA_CHAT]++;
					}
					case '1':
					{
						while(replace(szText, charsmax(szText), "!n", "^n")) {}
						ArrayPushString(g_aDataReklama[REKLAMA_HUD], szText);
						g_iReklamaListSize[REKLAMA_HUD]++;
					}
					case '2':
					{
						ArrayPushString(g_aDataReklama[REKLAMA_CMD], szText);
						TrieSetCell(g_tCommand, szCommand, g_iReklamaListSize[REKLAMA_CMD]);
						g_iReklamaListSize[REKLAMA_CMD]++;
					}
				}
			}
			if(g_iReklamaListSize[REKLAMA_CHAT]) set_task(17.0, "Task_ReklamaChat", _, _, _, "b");
			if(g_iReklamaListSize[REKLAMA_HUD]) set_task(33.0, "Task_ReklamaHud", _, _, _, "b");
		}
	}
}

public Task_ReklamaChat()
{
	if(++g_iReklamaNext[REKLAMA_CHAT] == g_iReklamaListSize[REKLAMA_CHAT]) g_iReklamaNext[REKLAMA_CHAT] = 0;
	static szText[256]; ArrayGetString(g_aDataReklama[REKLAMA_CHAT], g_iReklamaNext[REKLAMA_CHAT], szText, charsmax(szText));
	UTIL_SayText(0, szText);
}

public Task_ReklamaHud()
{
	if(++g_iReklamaNext[REKLAMA_HUD] == g_iReklamaListSize[REKLAMA_HUD]) g_iReklamaNext[REKLAMA_HUD] = 0;
	static szText[256], iRandom; ArrayGetString(g_aDataReklama[REKLAMA_HUD], g_iReklamaNext[REKLAMA_HUD], szText, charsmax(szText));
	iRandom = random_num(0, 9);
	set_dhudmessage(g_iColorsHud[iRandom][0], g_iColorsHud[iRandom][1], g_iColorsHud[iRandom][2], -1.0, 0.73, 2, 1.0, 10.0, 0.1, 1.0, false);
	show_dhudmessage(0, szText);
}

public ClCmd_Say(id)
{
	if(g_iReklamaListSize[REKLAMA_CMD])
	{
		static szText[256], iCell; read_args(szText, charsmax(szText));
		remove_quotes(szText);
		if(TrieKeyExists(g_tCommand, szText))
		{
			TrieGetCell(g_tCommand, szText, iCell);
			ArrayGetString(g_aDataReklama[REKLAMA_CMD], iCell, szText, charsmax(szText));
			UTIL_SayText(id, szText);
		}
	}
}

stock UTIL_SayText(pPlayer, const szMessage[], any:...)
{
	new szBuffer[190];
	if(numargs() > 2) vformat(szBuffer, charsmax(szBuffer), szMessage, 3);
	else copy(szBuffer, charsmax(szBuffer), szMessage);
	while(replace(szBuffer, charsmax(szBuffer), "!y", "^1")) {}
	while(replace(szBuffer, charsmax(szBuffer), "!t", "^3")) {}
	while(replace(szBuffer, charsmax(szBuffer), "!g", "^4")) {}
	switch(pPlayer)
	{
		case 0:
		{
			for(new iPlayer = 1; iPlayer <= g_iMaxPlayers; iPlayer++)
			{
				if(!is_user_connected(iPlayer)) continue;
				engfunc(EngFunc_MessageBegin, MSG_ONE_UNRELIABLE, MsgId_SayText, {0.0, 0.0, 0.0}, iPlayer);
				write_byte(iPlayer);
				write_string(szBuffer);
				message_end();
			}
		}
		default:
		{
			engfunc(EngFunc_MessageBegin, MSG_ONE_UNRELIABLE, MsgId_SayText, {0.0, 0.0, 0.0}, pPlayer);
			write_byte(pPlayer);
			write_string(szBuffer);
			message_end();
		}
	}
}